#include "Fcns.h"


//#define SPHERE
//#define TORE


//#define SWAP

#define X0_1 0.0
#define Y0_1 0.0
#define Z0_1 1.7
#define R0_1 0.5

#define X0_2 0.5
#define Y0_2 0.4
#define Z0_2 3.1
#define R0_2 0.7


extern int mode;
extern int NbComponentsAnd1;


interval Chii(const interval a,const interval b,const interval c)
{   
	iboolean test = In(a,interval(-oo,0));

	if (test == itrue)
	{
		return b;
	}
	else
	{
		if (test == ifalse)
		{
			return c;
		}
		else
		{
			return interval(min(b.inf, c.inf), max(b.sup,c.sup));
		}
	}
}

void Bisect(interval& x, interval& x1, interval& x2)
{
	x1 = x;	x2 = x;
	double mx = Center(x);
	x1.sup = mx;
	x2.inf = mx;
}

double sqr(double x)
{
	return x*x;
}

box fbox(interval x, interval y, interval z)
{
	interval fi1 = Sqr(x-X0_1)+Sqr(y-Y0_1)+Sqr(z-Z0_1)-Sqr(R0_1);
	interval fi2 = Sqr(x-X0_2)+Sqr(y-Y0_2)+Sqr(z-Z0_2)-Sqr(R0_2);

#ifdef SWAP
	return box(fi2, fi1);
#else
	return box(fi1, fi2);
#endif // SWAP
}

box gbox(box P, interval d)
{
	switch (mode)
	{
	case ACKERMANN:
		{
			interval r1 = P[1]+P[2]+2-3*d;
			interval r2 = Sqr(P[1]-1)+Sqr(P[2]-1)-Sqr(sigma)-2*d*((P[1]+P[2]+2)*(P[1]+P[2]+3-4*d)+4*Sqr(d));
			interval r3 = 2*(P[1]+3)*(P[2]+3)-16+Sqr(sigma)-d*((P[1]+P[2]+2)*(1+d)-Sqr(d));
			return box(r1, r2, r3);
		}
		//break;

	case RAYTRACING:
		return fbox(d*P[1],d*P[2],d);
		//break;

	default:
        return 0;
		//break;
	}
}

box gradgdbox(box P, interval d)
{
	switch (mode)
	{
	case ACKERMANN:
		{
			interval gradr1d = -3;
			interval gradr2d = -2*((P[1]+P[2]+2)*(P[1]+P[2]+3-8*d)+12*Sqr(d));
			interval gradr3d = (P[1]+P[2]+2)*(2*d-1)-3*Sqr(d);

			return box(gradr1d, gradr2d, gradr3d);
		}
		//break;

	case RAYTRACING:
		{
			interval p1 = P[1];
			interval p2 = P[2];
			interval gradg1di = 2*((d*p1-X0_1)*p1+(d*p2-Y0_1)*p2+(d-Z0_1));
			interval gradg2di = 2*((d*p1-X0_2)*p1+(d*p2-Y0_2)*p2+(d-Z0_2));

#ifdef SWAP
			return box(gradg2di, gradg1di);
#else
			return box(gradg1di, gradg2di);
#endif // SWAP
		}
		//break;

	default:
                return box();
		//break;
	}
}

box gradfxbox(interval x, interval y, interval z)
{
	interval gradf1xi = 2*(x-X0_1);
	interval gradf2xi = 2*(x-X0_2);

#ifdef SWAP
	return box(gradf2xi, gradf1xi);
#else
	return box(gradf1xi, gradf2xi);
#endif // SWAP
}

box gradfybox(interval x, interval y, interval z)
{
	interval gradf1yi = 2*(y-Y0_1);
	interval gradf2yi = 2*(y-Y0_2);

#ifdef SWAP
	return box(gradf2yi, gradf1yi);
#else
	return box(gradf1yi, gradf2yi);
#endif // SWAP
}

box gradfzbox(interval x, interval y, interval z)
{
	interval gradf1zi = 2*(z-Z0_1);
	interval gradf2zi = 2*(z-Z0_2);

#ifdef SWAP
	return box(gradf2zi, gradf1zi);
#else
	return box(gradf1zi, gradf2zi);
#endif // SWAP
}

interval gmin(box P, interval d)
{
	interval gmini = interval(oo);


	for (int i=1; i<NbComponentsAnd1; i++)
	{
		gmini = Min(gbox(P, d)[i], gmini);
	}

	return gmini;
}

interval gradgdmin(box P, interval d)
{
	interval a = interval(oo);
	interval b = interval(oo);


	for (int i=1; i<NbComponentsAnd1; i++)
	{
		b = Chii(a-gbox(P,d)[i],b,gradgdbox(P,d)[i]);
		a = gbox(P,d)[i];
	}

	return b;
}

interval gradfxmin(interval x, interval y, interval z)
{
	interval a = interval(oo);
	interval b = interval(oo);


	for (int i=1; i<NbComponentsAnd1; i++)
	{
		b = Chii(a-fbox(x,y,z)[i],b,gradfxbox(x,y,z)[i]);
		a = fbox(x,y,z)[i];
	}

	return b;
}

interval gradfymin(interval x, interval y, interval z)
{
	interval a = interval(oo);
	interval b = interval(oo);


	for (int i=1; i<NbComponentsAnd1; i++)
	{
		b = Chii(a-fbox(x,y,z)[i],b,gradfybox(x,y,z)[i]);
		a = fbox(x,y,z)[i];
	}

	return b;
}

interval gradfzmin(interval x, interval y, interval z)
{
	interval a = interval(oo);
	interval b = interval(oo);


	for (int i=1; i<NbComponentsAnd1; i++)
	{
		b = Chii(a-fbox(x,y,z)[i],b,gradfzbox(x,y,z)[i]);
		a = fbox(x,y,z)[i];
	}

	return b;
}

double pAckermann(double p1, double p2, double s)
{
	return pow(s,3)+(p1+p2+2)*sqr(s)+(p1+p2+2)*s+2*p1*p2+6*p1+6*p2+2+sqr(sigma);
}












