#include "Sivia.h"

//#define GRAY

extern int mode;
extern int NbComponentsAnd1;
extern vector<box> pCutOut;
extern vector<interval> dminIntervals;
extern double dmins[300][300];


iboolean Inside(box P, interval D, interval &Dmin)
{
	list<interval> L;
	interval D1 = interval(0);
	interval D2 = interval(0);
	double a = D.inf;
	double b = D.sup;
	double d_inf = 0;


	switch (mode)
	{
	case ACKERMANN:
		d_inf = D_INF_ACKERMANN;
		break;

	case RAYTRACING:

		d_inf = D_INF_RAYTRACING;
		break;

	default:
		break;
	}


	L.push_front(D);
	while (!L.empty())
	{
		D = L.front();
		L.pop_front();

		if (Width(D) < Width(P))
		{
			return iperhaps;
		}

		iboolean testgdinf = In(gmin(P,D.inf),interval(0,oo));

		if (testgdinf == ifalse)
		{
			return ifalse;
		}
		else
		{
			if ((testgdinf == iperhaps)&&(D.inf == d_inf))
			{
				return iperhaps;
			}
			else
			{
				if (testgdinf == itrue)
				{
					a = D.inf;
				}

				iboolean testg = In(gmin(P,D),interval(-oo,0));

				if (testg == ifalse)
				{
					a = D.sup;
				}
				else
				{
					iboolean testgradgd = In(gradgdmin(P,D),interval(-oo,0));

					if (testgradgd == itrue)
					{
						iboolean testgdsup = In(gmin(P,D.sup),interval(-oo,0));

						if ((testgdsup == itrue))
						{
							b = D.sup;
							Dmin = interval(a, b);
							return itrue;
						}
						else
						{
							if ((testgdsup == ifalse))
							{
								a = D.sup;
							}
						}
					}
					else
					{
						Bisect(D,D1,D2);
						L.push_front(D2);
						L.push_front(D1);
					}
				}
			}
		}
	}

	return ifalse;
}

void SIVIApile(repere R, box P)
{
	box P1(2);
	box P2(2);


	interval D;

	switch (mode)
	{
	case ACKERMANN:
		D = interval(D_INF_ACKERMANN,D_SUP_ACKERMANN);
		break;

	case RAYTRACING:

		D = interval(D_INF_RAYTRACING,D_SUP_RAYTRACING);
		break;

	default:
		break;
	}

	interval Dmin = interval(0);
	double sizeX = 0.0;
	double sizeY = 0.0;

	R.GetCSPixelSize(sizeX, sizeY);

	double epsilon = min(sizeX, sizeY);


	if (Width(P) < epsilon/2)
	{
		R.DrawBox(P,clYellow,clYellow,bsSolid);
		/*		switch (mode)
		{
		case ACKERMANN:
		dispColor(P, clWhite);
		break;

		case RAYTRACING:
		dispColor(P, clBlack);
		break;

		default:
		break;
		}
		*/
		return;
	}

	iboolean test = Inside(P,D,Dmin);

	if (test == itrue)
	{
		disp(R, P, Dmin);
	}
	else if (test == iperhaps)
	{
		Bisect(P,P1,P2);
		SIVIApile(R, P1);
		SIVIApile(R, P2);
	}
	else
	{
		R.DrawBox(P,clBlue,clBlue,bsSolid);
	}
}

void SIVIApileProgress(repere R, box P, TImage* Image)
{
	box P1(2);
	box P2(2);


	interval D;

	switch (mode)
	{
	case ACKERMANN:
		D = interval(D_INF_ACKERMANN,D_SUP_ACKERMANN);
		break;

	case RAYTRACING:

		D = interval(D_INF_RAYTRACING,D_SUP_RAYTRACING);
		break;

	default:
		break;
	}

	interval Dmin = interval(0);
	double sizeX = 0.0;
	double sizeY = 0.0;

	R.GetCSPixelSize(sizeX, sizeY);

	double epsilon = min(sizeX, sizeY);


	if (Width(P) < epsilon)
	{
		R.DrawBox(P,clYellow,clYellow,bsSolid);
		Image->Repaint();
		return;
	}

	iboolean test = Inside(P,D,Dmin);

	if (test == itrue)
	{
		disp(R, P, Dmin);
		Image->Repaint();
	}
	else if (test == iperhaps)
	{
		Bisect(P,P1,P2);
		SIVIApileProgress(R, P1, Image);
		SIVIApileProgress(R, P2, Image);
	}
	else
	{
		R.DrawBox(P,clBlue,clBlue,bsSolid);
		Image->Repaint();
	}
}

void SIVIApileProgressBoxes(repere R, box P, TImage* Image)
{
	box P1(2);
	box P2(2);


	interval D;

	switch (mode)
	{
	case ACKERMANN:
		D = interval(D_INF_ACKERMANN,D_SUP_ACKERMANN);
		break;

	case RAYTRACING:

		D = interval(D_INF_RAYTRACING,D_SUP_RAYTRACING);
		break;

	default:
		break;
	}

	interval Dmin = interval(0);
	double sizeX = 0.0;
	double sizeY = 0.0;

	R.GetCSPixelSize(sizeX, sizeY);

	double epsilon = min(sizeX, sizeY);


	if (Width(P) < epsilon)
	{
		//pCutOut.push_back(P);
		R.DrawBox(P,clYellow,clWhite,bsSolid);
		Image->Repaint();
		return;
	}

	iboolean test = Inside(P,D,Dmin);

	if (test == itrue)
	{
		pCutOut.push_back(P);
		dminIntervals.push_back(Dmin);
		disp(R, P, Dmin);
		R.DrawCadre(P,clWhite, psSolid);
		Image->Repaint();
	}
	else if (test == iperhaps)
	{
		Bisect(P,P1,P2);
		SIVIApileProgressBoxes(R, P1, Image);
		SIVIApileProgressBoxes(R, P2, Image);
	}
	else
	{
		//pCutOut.push_back(P);
		R.DrawBox(P,clBlue,clWhite,bsSolid);
		Image->Repaint();
	}
}

void disp(repere R, box P, interval Dmin)
{
	unsigned int pi0 = 0;
	unsigned int pj0 = 0;
	unsigned int pi1 = 0;
	unsigned int pj1 = 0;


	R.XYCS2IJImg(P[1].inf, P[2].sup, pi0, pj0);
	R.XYCS2IJImg(P[1].sup, P[2].inf, pi1, pj1);

	for (unsigned int pi = pi0; pi < pi1; pi++)
	{
		for (unsigned int pj = pj0; pj < pj1; pj++)
		{
			double px = 0.0;
			double py = 0.0;


			R.IJImg2XYCS(pi, pj, px, py);

			box Ppxpy = box(interval(px),interval(py));

			double d0 = Dmin.inf;
			double d1 = Dmin.sup;
			double dmin = (d0+d1)/2.0;

			while (d1-d0 > EPSILON_DICHOTHOMIE)
			{
				if (In(gmin(Ppxpy,d0)*gmin(Ppxpy,dmin),interval(0,oo)) == itrue)
				{
					d0 = dmin;
				}
				else
				{
					d1 = dmin;
				}

				dmin = (d0+d1)/2.0;
			}

			dmins[pj][pi] = dmin;

			double red = 0;
			double green = 0;
			double blue = 0;

			switch (mode)
			{
			case ACKERMANN:
				{
					red = max(min(255.0*dmin, 255.0), 0.0);
					green = max(min(255.0*dmin, 255.0), 0.0);
					blue = max(min(255.0*dmin, 255.0), 0.0);
				}
				break;

			case RAYTRACING:
				{
					double nx = 0;
					double ny = 0;
					double nz = 0;

					// Normal at the point
					nx = gradfxmin(dmin*px, dmin*py, dmin).inf;
					ny = gradfymin(dmin*px, dmin*py, dmin).inf;
					nz = gradfzmin(dmin*px, dmin*py, dmin).inf;

					light(px,py,dmin,nx,ny,nz,red,green,blue);
				}
				break;

			default:
				break;
			}

			R.canvas->Pixels[pj][pi] = (TColor)RGB(red, green, blue);
		}
	}
}

void light(double px, double py, double dmin, double nx, double ny, double nz, double &red, double &green, double &blue)
{
	// Phong illumination model

	// Vector from the point to the eye. To compute more precisely ?
	double ex = 0.0;
	double ey = 0.0;
	double ez = -1.0;

	// Direction of the light
	double lx = 0.0;
	double ly = 0.0;
	double lz = -1.0;

	double normn = sqrt(
		sqr(nx)+
		sqr(ny)+
		sqr(nz)
		);

	if (normn != 0)
	{
		nx = nx/normn;
		ny = ny/normn;
		nz = nz/normn;
	}

	double produit_scalaire_nl = nx*lx+ny*ly+nz*lz;

	// Reflection ray
	double rx = -lx + 2.0*produit_scalaire_nl*nx;
	double ry = -ly + 2.0*produit_scalaire_nl*ny;
	double rz = -lz + 2.0*produit_scalaire_nl*nz;

	double normr = sqrt(
		sqr(rx)+
		sqr(ry)+
		sqr(rz)
		);

	if (normr != 0)
	{
		rx = rx/normr;
		ry = ry/normr;
		rz = rz/normr;
	}

	double produit_scalaire_er = ex*rx+ey*ry+ez*rz;


	double ka = 0.05; //Ambient reflection constant, the ratio of reflection of the ambient term present in all points in the scene rendered
	double kd = 0.70; // Diffuse reflection constant, the ratio of reflection of the diffuse term of incoming light
	double ks = 0.25; // Specular reflection constant, the ratio of reflection of the specular term of incoming light
	double p = 10; // Shininess constant for this material, which decides how "evenly" light is reflected from a shiny spot, and is very large for most surfaces, on the order of 50, getting larger the more mirror-like they are

	double Kred = 0.156;
	double Kgreen = 0.045;
	double Kblue = 0.040;

#ifndef GRAY
	red = exp(-Kred*dmin*0.0)*(ka*255.0+kd*max(0.0,produit_scalaire_nl)*255.0+ks*pow(max(0.0,produit_scalaire_er),p)*255.0);
	green = exp(-Kgreen*dmin*0.0)*(ka*0.0+kd*max(0.0,produit_scalaire_nl)*0.0+ks*pow(max(0.0,produit_scalaire_er),p)*255.0);
	blue = exp(-Kblue*dmin*0.0)*(ka*0.0+kd*max(0.0,produit_scalaire_nl)*0.0+ks*pow(max(0.0,produit_scalaire_er),p)*255.0);
#else
	red = max(min((3.1-dmin)*120, 255.0), 0.0);
	green = max(min((3.1-dmin)*120, 255.0), 0.0);
	blue = max(min((3.1-dmin)*120, 255.0), 0.0);
#endif // GRAY
}
